# -*- coding: utf-8 -*-
# Generated by Django 1.10.6 on 2017-04-05 20:11
from __future__ import unicode_literals

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models

import core.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Feedback',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('text', models.TextField()),
                ('slug', models.SlugField(default=core.models.random_slug, editable=False, unique=True)),
                ('score', models.PositiveIntegerField(default=0)),
                ('status', models.CharField(choices=[('I', 'editable'), ('A', 'accepted'), ('R', 'request review'), ('O', 'request reassignment')], default='I', max_length=1)),
                ('origin', models.CharField(choices=[('E', 'was empty'), ('UT', 'passed unittests'), ('CF', 'did not compile'), ('LF', 'could not link'), ('M', 'created by a human. yak!')], default='M', max_length=2)),
                ('of_reviewer', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='reviewed_submissions', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Feedback',
                'verbose_name_plural': 'Feedback Set',
            },
        ),
        migrations.CreateModel(
            name='Student',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('matrikel_no', models.CharField(default=core.models.random_matrikel_no, max_length=8, unique=True)),
                ('name', models.CharField(default='__no_name__', max_length=50)),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Student',
                'verbose_name_plural': 'Student Set',
            },
        ),
        migrations.CreateModel(
            name='Submission',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('slug', models.SlugField(default=core.models.random_slug, editable=False, unique=True)),
                ('seen', models.BooleanField(default=False)),
                ('text', models.TextField(blank=True)),
                ('pre_corrections', models.TextField(blank=True)),
                ('final_feedback', models.OneToOneField(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='core.Feedback')),
                ('student', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.Student')),
            ],
            options={
                'verbose_name': 'Submission',
                'verbose_name_plural': 'Submission Set',
            },
        ),
        migrations.CreateModel(
            name='SubmissionType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=50, unique=True)),
                ('slug', models.SlugField(default=core.models.random_slug, editable=False, unique=True)),
                ('full_score', models.PositiveIntegerField(default=0)),
                ('task_description', models.TextField()),
                ('possible_solution', models.TextField()),
                ('correction_guideline', models.TextField()),
            ],
            options={
                'verbose_name': 'SubmissionType',
                'verbose_name_plural': 'SubmissionType Set',
            },
        ),
        migrations.AddField(
            model_name='submission',
            name='type',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='submissions', to='core.SubmissionType'),
        ),
        migrations.AddField(
            model_name='feedback',
            name='of_submission',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='feedback_list', to='core.Submission'),
        ),
        migrations.AddField(
            model_name='feedback',
            name='of_tutor',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='corrected_submissions', to=settings.AUTH_USER_MODEL),
        ),
    ]
