import csv

from django.http import HttpResponse

from core.custom_annotations import group_required
from core.models import Student, SubmissionType


@group_required('Reviewers')
def export_csv(request):
    # Create the HttpResponse object with the appropriate CSV header.
    response = HttpResponse(content_type='text/csv')
    response['Content-Disposition'] = 'attachment; filename="grady_results.csv"'

    writer = csv.writer(response)
    writer.writerow(['Matrikel', 'Username',  'Name', 'Sum'] +
                    [s.name for s in SubmissionType.objects.all().order_by('name')])

    for student in Student.get_overall_score_annotated_submission_list():
        writer.writerow([
            student.matrikel_no,
            student.user.username,
            student.name,
            student.overall_score,
            *student.score_per_submission().values()
        ])

    return response
